diff -rupN seq24-rev48 adding win32/src/seq24.cpp seq24-rev48 win32 adding MouseInteraction/src/seq24.cpp
--- seq24-rev48 adding win32/src/seq24.cpp	2009-05-20 20:30:47.125000000 -0500
+++ seq24-rev48 win32 adding MouseInteraction/src/seq24.cpp	2009-05-20 20:30:51.390625000 -0500
@@ -48,6 +48,7 @@ option long_options[] = {
     {"stats",     0, 0, 'S' },
     {"priority", 0, 0, 'p' },
     {"ignore",required_argument, 0, 'i'},
+    {"interaction_method",required_argument, 0, 'x'},
     {"jack_transport",0, 0, 'j'},
     {"jack_master",0, 0, 'J'},
     {"jack_master_cond",0,0,'C'},
@@ -71,6 +72,7 @@ Glib::ustring last_used_dir ="/";
 std::string config_filename = ".seq24rc";
 std::string user_filename = ".seq24usr";
 bool global_print_keys = false;
+interaction_method_e global_interactionmethod = e_seq24_interaction;
 
 bool global_with_jack_transport = false;
 bool global_with_jack_master = false;
@@ -183,6 +185,7 @@ main (int argc, char *argv[])
                 printf( "    --priority : runs higher priority with FIFO scheduler (must be root)\n" );
                 printf( "    --pass_sysex : passes any incoming sysex messages to all outputs \n" );
                 printf( "    --show_keys : prints pressed key value\n" );
+                printf( "    --interaction_method <number>: see .seq24rc for methods to use\n" );
                 printf( "    --jack_transport : seq24 will sync to jack transport\n" );
                 printf( "    --jack_master : seq24 will try to be jack master\n" );
                 printf( "    --jack_master_cond : jack master will fail if there is already a master\n" );
@@ -249,6 +252,10 @@ main (int argc, char *argv[])
                 global_device_ignore_num = atoi( optarg );
                 break;
                 
+            case 'x':
+                global_interactionmethod = (interaction_method_e)atoi( optarg );
+                break;
+
                 
             default:
                 break;
diff -rupN seq24-rev48 adding win32/src/seqevent.cpp seq24-rev48 win32 adding MouseInteraction/src/seqevent.cpp
--- seq24-rev48 adding win32/src/seqevent.cpp	2009-05-20 20:30:47.375000000 -0500
+++ seq24-rev48 win32 adding MouseInteraction/src/seqevent.cpp	2009-05-20 20:30:51.640625000 -0500
@@ -57,7 +57,6 @@ seqevent::seqevent(sequence *a_seq,
     m_moving    = false;
     m_moving_init = false;
     m_growing   = false;
-    m_adding    = false;
     m_paste     = false;
     m_painting  = false;
     
@@ -559,203 +558,409 @@ seqevent::convert_t( long a_ticks, int *
 }
 
 
-/* popup menu calls this */
+
+
+
+bool 
+seqevent::on_button_press_event(GdkEventButton* a_ev)
+{
+    switch (global_interactionmethod)
+    {
+        case e_fruity_interaction:
+             return m_fruity_interaction.on_button_press_event(a_ev, *this);
+        case e_seq24_interaction:
+             return m_seq24_interaction.on_button_press_event(a_ev, *this);
+    }
+    return false;
+}
+
 void
-seqevent::set_adding( bool a_adding )
+seqevent::drop_event( long a_tick )
 {
-    if ( a_adding ){
- 
-	get_window()->set_cursor(  Gdk::Cursor( Gdk::PENCIL ));
-	m_adding = true;
+
+    unsigned char status = m_status;
+    unsigned char d0 = m_cc;
+    unsigned char d1 = 0x40;
+
+    if ( m_status == EVENT_AFTERTOUCH )
+        d0 = 0;
+
+    if ( m_status == EVENT_PROGRAM_CHANGE )
+        d0 = 0; /* d0 == new patch */
+
+    if ( m_status == EVENT_CHANNEL_PRESSURE )
+        d0 = 0x40; /* d0 == pressure */
+
+    if ( m_status == EVENT_PITCH_WHEEL )
+        d0 = 0;
+
+    m_seq->add_event( a_tick, 
+            status,
+            d0,
+            d1, true );
+}
+
+
+bool 
+seqevent::on_button_release_event(GdkEventButton* a_ev)
+{
+    switch (global_interactionmethod)
+    {
+        case e_fruity_interaction:
+             return m_fruity_interaction.on_button_release_event(a_ev, *this);
+        case e_seq24_interaction:
+             return m_seq24_interaction.on_button_release_event(a_ev, *this);
     }
-    else {
+    return false;
+}
+
+
 
-	get_window()->set_cursor( Gdk::Cursor( Gdk::LEFT_PTR ));
-	m_adding = false;
+bool
+seqevent::on_motion_notify_event(GdkEventMotion* a_ev)
+{
+    switch (global_interactionmethod)
+    {
+        case e_fruity_interaction:
+             return m_fruity_interaction.on_motion_notify_event(a_ev, *this);
+        case e_seq24_interaction:
+             return m_seq24_interaction.on_motion_notify_event(a_ev, *this);
     }
+    return false;
+}
+
+
+
+/* performs a 'snap' on y */
+void 
+seqevent::snap_y( int *a_y )
+{
+    *a_y = *a_y - (*a_y % c_key_y);
+}
+
+/* performs a 'snap' on x */
+void 
+seqevent::snap_x( int *a_x )
+{
+    //snap = number pulses to snap to
+    //m_zoom = number of pulses per pixel
+    //so snap / m_zoom  = number pixels to snap to
+    int mod = (m_snap / m_zoom);
+    if ( mod <= 0 )
+        mod = 1;
+    
+    *a_x = *a_x - (*a_x % mod );
+  
 }
 
 
 bool 
-seqevent::on_button_press_event(GdkEventButton* a_ev)
+seqevent::on_focus_in_event(GdkEventFocus*)
 {
-    int x,w,numsel;
+    set_flags(Gtk::HAS_FOCUS);
+    return false;
+}
+
+bool 
+seqevent::on_focus_out_event(GdkEventFocus*)
+{
+    unset_flags(Gtk::HAS_FOCUS);
+    return false;
+}
+
+bool
+seqevent::on_key_press_event(GdkEventKey* a_p0)
+{
+    bool ret = false;
+
+    if ( a_p0->type == GDK_KEY_PRESS ){
+
+        if ( a_p0->keyval ==  GDK_Delete || a_p0->keyval == GDK_BackSpace ){
+
+            m_seq->push_undo();
+            m_seq->mark_selected();
+            m_seq->remove_marked();
+            ret = true;
+        }
+
+        if ( a_p0->state & GDK_CONTROL_MASK ){
+
+            /* cut */
+            if ( a_p0->keyval == GDK_x || a_p0->keyval == GDK_X ){
+
+                m_seq->copy_selected();
+                m_seq->mark_selected();
+                m_seq->remove_marked();
+
+                ret = true;
+            }
+            /* copy */
+            if ( a_p0->keyval == GDK_c || a_p0->keyval == GDK_C ){
+
+                m_seq->copy_selected();
+                ret = true;
+            }
+            /* paste */
+            if ( a_p0->keyval == GDK_v || a_p0->keyval == GDK_V ){
+
+                start_paste();
+                ret = true;
+            }
+            /* Undo */
+            if ( a_p0->keyval == GDK_z || a_p0->keyval == GDK_Z ){
+
+                m_seq->pop_undo();
+                ret = true;
+            }
+         }
+    }
+
+    if ( ret == true ){
+
+        redraw();
+        m_seq->set_dirty();
+        return true;
+    }
+    else
+
+        return false;
+}
+
+
+
+
+
+//////////////////////////
+// interaction methods
+//////////////////////////
+
+
+void FruitySeqEventInput::updateMousePtr(seqevent& ths)
+{
+    // context sensitive mouse
+    long tick_s, tick_w, tick_f, pos;
+    ths.convert_x( ths.m_current_x, &tick_s );
+    ths.convert_x( c_eventevent_x, &tick_w  );
+    tick_f = tick_s + tick_w;
+    if ( tick_s < 0 )
+        tick_s = 0; // clamp to 0
+
+
+    if (m_is_drag_pasting || ths.m_selecting || ths.m_moving || ths.m_paste)
+    {
+        ths.get_window()->set_cursor( Gdk::Cursor( Gdk::LEFT_PTR ));
+    }
+    else if (ths.m_seq->intersectEvents( tick_s, tick_f, ths.m_status, pos ))
+    {
+        ths.get_window()->set_cursor( Gdk::Cursor( Gdk::CENTER_PTR ));
+    }
+    else
+    {
+        ths.get_window()->set_cursor( Gdk::Cursor( Gdk::PENCIL ));
+    }
+}
+
+
+bool FruitySeqEventInput::on_button_press_event(GdkEventButton* a_ev, seqevent& ths)
+{
+     int x,w,numsel;
 
     long tick_s;
     long tick_f;
     long tick_w;
 
-    convert_x( c_eventevent_x, &tick_w  );
+    ths.convert_x( c_eventevent_x, &tick_w  );
 
     /* if it was a button press */
 
     /* set values for dragging */
-    m_drop_x = m_current_x = (int) a_ev->x + m_scroll_offset_x;
+    ths.m_drop_x = ths.m_current_x = (int) a_ev->x + ths.m_scroll_offset_x;
 
     /* reset box that holds dirty redraw spot */
-    m_old.x = 0;
-    m_old.y = 0;
-    m_old.width = 0;
-    m_old.height = 0;
-
-    if ( m_paste ){
-
-        snap_x( &m_current_x );
-        convert_x( m_current_x, &tick_s );
-        m_paste = false;
-        m_seq->push_undo();
-        m_seq->paste_selected( tick_s, 0 );
+    ths.m_old.x = 0;
+    ths.m_old.y = 0;
+    ths.m_old.width = 0;
+    ths.m_old.height = 0;
+
+    if ( ths.m_paste ){
+
+        ths.snap_x( &ths.m_current_x );
+        ths.convert_x( ths.m_current_x, &tick_s );
+        ths.m_paste = false;
+        ths.m_seq->push_undo();
+        ths.m_seq->paste_selected( tick_s, 0 );
 
     } else {
 
         /*      left mouse button     */
-        if ( a_ev->button == 1 ){ 
-
+        if ( a_ev->button == 1 )
+        {
             /* turn x,y in to tick/note */
-            convert_x( m_drop_x, &tick_s );
+            ths.convert_x( ths.m_drop_x, &tick_s );
 
             /* shift back a few ticks */
-            tick_f = tick_s + (m_zoom);
+            tick_f = tick_s + (ths.m_zoom);
             tick_s -= (tick_w);
 
-            if ( tick_s < 0 ) 
+            if ( tick_s < 0 )
                 tick_s = 0;
 
-            if ( m_adding )
+            if ( ! ths.m_seq->select_events( tick_s, tick_f,
+                            ths.m_status, ths.m_cc, sequence::e_would_select ) &&
+                 !(a_ev->state & GDK_CONTROL_MASK) )
             {
-                m_painting = true;
+                ths.m_painting = true;
 
-                snap_x( &m_drop_x );
+                ths.snap_x( &ths.m_drop_x );
                 /* turn x,y in to tick/note */
-                convert_x( m_drop_x, &tick_s );
-                /* add note, length = little less than snap */
+                ths.convert_x( ths.m_drop_x, &tick_s );
 
-                if ( ! m_seq->select_events( tick_s, tick_f,
-                            m_status, m_cc, sequence::e_would_select ))
+                /* add note, length = little less than snap */
+                if ( ! ths.m_seq->select_events( tick_s, tick_f,
+                            ths.m_status, ths.m_cc, sequence::e_would_select ))
                 {
-                    m_seq->push_undo();
-                    drop_event( tick_s );
+                    ths.m_seq->push_undo();
+                    ths.drop_event( tick_s );
                 }
 
             }
             else /* selecting */
             {
-                if ( ! m_seq->select_events( tick_s, tick_f,
-                            m_status, m_cc, sequence::e_is_selected ))
+                if ( ! ths.m_seq->select_events( tick_s, tick_f,
+                            ths.m_status, ths.m_cc, sequence::e_is_selected ))
                 {
-                    if ( ! (a_ev->state & GDK_CONTROL_MASK) )
+                    // if clicking event...
+                    if (ths.m_seq->select_events( tick_s, tick_f,
+                            ths.m_status, ths.m_cc, sequence::e_would_select ) )
                     {
-                        m_seq->unselect();
-                    }
-
-                    numsel = m_seq->select_events( tick_s, tick_f,
-                            m_status,
-                            m_cc, sequence::e_select_one );
-
-                    /* if we didnt select anyhing (user clicked empty space)
-                       unselect all notes, and start selecting */
-
-                    /* none selected, start selection box */
-                    if ( numsel == 0 )
-                    { 
-                        m_selecting = true;
+                        if ( ! (a_ev->state & GDK_CONTROL_MASK) )
+                           ths.m_seq->unselect();
                     }
+                    // if clicking empty space ...
                     else
                     {
-                        /// needs update
+                        // ... unselect all if ctrl-shift not held
+                        if (! ((a_ev->state & GDK_CONTROL_MASK) &&
+                               (a_ev->state & GDK_SHIFT_MASK)) )
+                           ths.m_seq->unselect();
                     }
+
+                    /* on direct click select only one event */
+                    numsel = ths.m_seq->select_events( tick_s, tick_f,
+                            ths.m_status,
+                            ths.m_cc, sequence::e_select_one );
+
+                    // prevent deselect in button_release()
+                    if (numsel)
+                       m_justselected_one = true;
+
+                    // if nothing selected, start the selection box
+                    if (numsel == 0 && (a_ev->state & GDK_CONTROL_MASK))
+                        ths.m_selecting = true;
                 }
 
-                if ( m_seq->select_events( tick_s, tick_f,
-                            m_status, m_cc, sequence::e_is_selected ))
+                // if event under cursor is selected
+                if ( ths.m_seq->select_events( tick_s, tick_f,
+                            ths.m_status, ths.m_cc, sequence::e_is_selected ))
                 {
 
-                    m_moving_init = true;
-                    int note;
+                    // grab/move the note
+                    if ( !(a_ev->state & GDK_CONTROL_MASK) )
+                    {
+                        ths.m_moving_init = true;
+                        int note;
 
-                    /* get the box that selected elements are in */
-                    m_seq->get_selected_box( &tick_s, &note, 
-                            &tick_f, &note );
+                        /* get the box that selected elements are in */
+                        ths.m_seq->get_selected_box( &tick_s, &note,
+                                &tick_f, &note );
 
-                    tick_f += tick_w;
+                        tick_f += tick_w;
 
-                    /* convert box to X,Y values */
-                    convert_t( tick_s, &x );
-                    convert_t( tick_f, &w );
+                        /* convert box to X,Y values */
+                        ths.convert_t( tick_s, &x );
+                        ths.convert_t( tick_f, &w );
 
-                    /* w is actually corrids now, so we have to change */
-                    w = w-x; 
+                        /* w is actually corrids now, so we have to change */
+                        w = w-x;
 
-                    /* set the m_selected rectangle to hold the
-                       x,y,w,h of our selected events */
+                        /* set the m_selected rectangle to hold the
+                           x,y,w,h of our selected events */
 
-                    m_selected.x = x;                  
-                    m_selected.width=w;
+                        ths.m_selected.x = x;
+                        ths.m_selected.width=w;
 
-                    m_selected.y = (c_eventarea_y - c_eventevent_y)/2;
-                    m_selected.height = c_eventevent_y;
+                        ths.m_selected.y = (c_eventarea_y - c_eventevent_y)/2;
+                        ths.m_selected.height = c_eventevent_y;
 
 
-                    /* save offset that we get from the snap above */
-                    int adjusted_selected_x = m_selected.x;
-                    snap_x( &adjusted_selected_x );
-                    m_move_snap_offset_x = ( m_selected.x - adjusted_selected_x);
+                        /* save offset that we get from the snap above */
+                        int adjusted_selected_x = ths.m_selected.x;
+                        ths.snap_x( &adjusted_selected_x );
+                        ths.m_move_snap_offset_x = ( ths.m_selected.x - adjusted_selected_x);
 
-                    /* align selection for drawing */
-                    snap_x( &m_selected.x );
-                    snap_x( &m_current_x );
-                    snap_x( &m_drop_x );
+                        /* align selection for drawing */
+                        ths.snap_x( &ths.m_selected.x );
+                        ths.snap_x( &ths.m_current_x );
+                        ths.snap_x( &ths.m_drop_x );
+                    }
+                    // ctrl left click when stuff is already selected
+                    else if ((a_ev->state & GDK_CONTROL_MASK) &&
+                             ths.m_seq->select_events( tick_s, tick_f,
+                                                  ths. m_status, ths.m_cc, sequence::e_is_selected ))
+                    {
+                        m_is_drag_pasting_start = true;
+                    }
 
-                } 
+                }
             }
 
         } /* end if button == 1 */
 
-        if ( a_ev->button == 3 ){ 
-
-            set_adding( true );
-        }
-    }
-
-    /* if they clicked, something changed */
-    update_pixmap();
-    draw_pixmap_on_window();  
-
-    return true;
-
-
-}
-
+        if ( a_ev->button == 3 )
+        {
+            /* turn x,y in to tick/note */
+            ths.convert_x( ths.m_drop_x, &tick_s );
 
-void
-seqevent::drop_event( long a_tick )
-{
+            /* shift back a few ticks */
+            tick_f = tick_s + (ths.m_zoom);
+            tick_s -= (tick_w);
 
-    unsigned char status = m_status;
-    unsigned char d0 = m_cc;
-    unsigned char d1 = 0x40;
+            if ( tick_s < 0 )
+                tick_s = 0;
 
-    if ( m_status == EVENT_AFTERTOUCH )
-        d0 = 0;
+            //erase event under cursor if there is one
+            if (ths.m_seq->select_events( tick_s, tick_f,
+                            ths.m_status, ths.m_cc, sequence::e_would_select ))
+            {
+                /* remove only the note under the cursor,
+                   leave the selection intact */
+                ths.m_seq->push_undo();
+                ths.m_seq->select_events( tick_s, tick_f,
+                            ths.m_status, ths.m_cc, sequence::e_remove_one );
+                ths.redraw();
+                ths.m_seq->set_dirty();
+            }
+            else /* selecting */
+            {
+                if  ( ! (a_ev->state & GDK_CONTROL_MASK) )
+                    ths.m_seq->unselect();
 
-    if ( m_status == EVENT_PROGRAM_CHANGE )
-        d0 = 0; /* d0 == new patch */
+                // nothing selected, start the selection box
+                ths.m_selecting = true;
+            }
+        }
+    }
 
-    if ( m_status == EVENT_CHANNEL_PRESSURE )
-        d0 = 0x40; /* d0 == pressure */
+    /* if they clicked, something changed */
+    ths.update_pixmap();
+    ths.draw_pixmap_on_window();
 
-    if ( m_status == EVENT_PITCH_WHEEL )
-        d0 = 0;
+    updateMousePtr( ths );
 
-    m_seq->add_event( a_tick, 
-            status,
-            d0,
-            d1, true );
+    return true;
 }
 
-
-bool 
-seqevent::on_button_release_event(GdkEventButton* a_ev)
+bool FruitySeqEventInput::on_button_release_event(GdkEventButton* a_ev, seqevent& ths)
 {
     long tick_s;
     long tick_f;
